package ch.uzh.ifi.sparqlml.arq.create.engine.ml;

import ch.uzh.ifi.sparqlml.arq.create.engine.QueryEngineFactory;
import ch.uzh.ifi.sparqlml.arq.create.engine.QueryEngineOpBase;
import ch.uzh.ifi.sparqlml.arq.create.engine.QueryEngineRegistry;
import ch.uzh.ifi.sparqlml.arq.create.query.QueryExecutionML;
import ch.uzh.ifi.sparqlml.arq.create.query.QueryML;

import com.hp.hpl.jena.query.Dataset;
import com.hp.hpl.jena.sparql.algebra.AlgebraGenerator;
import com.hp.hpl.jena.sparql.util.Context;

public class QueryEngineML extends QueryEngineOpBase {

	static public QueryEngineFactory getFactory() {
		return factory;
	}

	static public void register() {
		QueryEngineRegistry.addFactory(factory);
	}

	static public void unregister() {
		QueryEngineRegistry.removeFactory(factory);
	}

	public QueryEngineML(QueryML query, Context context) {
		super(query, new AlgebraGenerator(context), context, new OpExecML());
	}

	public QueryEngineML(QueryML query) {
		this(query, null);
	}

	// -------- Factory

	private static QueryEngineFactory factory = new QueryEngineFactory() {
		public boolean accept(QueryML query, Dataset dataset) {
			return true;
		}

		public QueryExecutionML create(QueryML query, Dataset dataset) {
			QueryEngineML engine = new QueryEngineML(query);
			engine.setDataset(dataset);
			return engine;
		}
	};
}
