/*
 * Resources.java (10.12.2007)
 * 
 * See LICENSE for more information about licensing and warranties.
 */
package ch.uzh.ifi.sparqlml.mining.core;

import java.util.HashMap;

/**
 * Holds all resources of the resultset and offers functions to manipulate them
 * 
 * @author Andr Locher
 */

public class Resources {
	public HashMap<String, Integer> objects;

	public int objCounter = 0;

	public Resources() {
		objects = new HashMap<String, Integer>();
	}

	/**
	 * Adds a new resource to the internal map.
	 * 
	 * @param object
	 */
	public void addObject(String object) {
		objCounter++;
		objects.put(object, objCounter);
	}

	/**
	 * Returns true if the internal map already contains the resource.
	 * 
	 * @param object
	 * @return
	 */
	public boolean containsObject(String object) {
		if (objects.containsKey(object)) {
			return true;
		}
		return false;
	}

	/**
	 * Returns the ID of a given resource.
	 * 
	 * @param object
	 * @return
	 */
	public int getObjectId(String object) {
		return objects.get(object).intValue();
	}

	/**
	 * Returns the number of resources in the internal map.
	 * 
	 * @param object
	 * @return
	 */
	public int getSize() {
		return objects.size();
	}

	public void getObjects() {

	}
	/*
	 * public String toString() { System.out.println("OBJECTS"); String output =
	 * ""; Iterator iter = objects.entrySet().iterator(); while (iter.hasNext()) {
	 * output += iter.next() + "\n"; } return output; }
	 */
}
