/*
 * BaseWriter.java (10.12.2007)
 * 
 * See LICENSE for more information about licensing and warranties.
 */
package ch.uzh.ifi.sparqlml.mining.module;

import java.io.FileNotFoundException;
import java.io.PrintWriter;

/**
 * BaseWriter which can be extended by a custom mining module writer
 * 
 * @author Andr Locher
 */
public class BaseWriter {

	/** Path to location of mining data */
	public static String dataPath = System.getenv("ARQROOT")
			+ System.getProperty("file.separator") + "mining"
			+ System.getProperty("file.separator") + "data"
			+ System.getProperty("file.separator");

	public PrintWriter writer;

	public static String space = "   ";

	public String model = "";

	public BaseWriter(String model, String fileExtension) {

		this.model = model;
		try {
			writer = new PrintWriter(dataPath + model + "." + fileExtension);
		} catch (FileNotFoundException e) {
			System.out
					.println("Make sure there is a /mining/data subfolder in your ARQROOT.");
			e.printStackTrace();
		}
	}

	/**
	 * Method to export the internal subgraph datastructure to an intermediate
	 * format.
	 */
	public void write() {

	}
}
