package ch.uzh.ifi.sparqlml.test;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.List;

import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.rdf.model.RDFNode;
import com.hp.hpl.jena.rdf.model.Resource;
import com.hp.hpl.jena.rdf.model.ResourceFactory;
import com.hp.hpl.jena.rdf.model.Statement;
import com.hp.hpl.jena.rdf.model.StmtIterator;
import com.hp.hpl.jena.util.FileManager;

public class AddTriples {

	public static String file = "test/dbpedia/yago_classes_b.nt";

	public static void main(String[] args) {
		Model container = ModelFactory.createDefaultModel();
		InputStream in = null;
		in = FileManager.get().open(file);
		container.read(in, "", "N-TRIPLES");
		
		addTriples(container);

		OutputStream out = null;
		try {
			out = new FileOutputStream(file);
		} catch (FileNotFoundException e) {
			System.out.println("Missing meta_models.rdf file.");
			e.printStackTrace();
		}
		container.write(out, "N-TRIPLES");

		container.close();
	}

	private static void addTriples(Model container) {
		String prop = "http://www.outerlimits.ch/properties#select";

		StmtIterator i = container
				.listStatements(
						null,
						ResourceFactory
								.createProperty("http://www.w3.org/1999/02/22-rdf-syntax-ns#type"),
						(RDFNode) null);

		List l = i.toList();

		Resource subject = null;
		String object = "";

		for (int v = 0; v < l.size(); v++) {
			Statement t = (Statement) l.get(v);
			subject = t.getSubject();
			container.add(subject, ResourceFactory.createProperty(prop), "YES");
		}

	}

}
