package ch.uzh.ifi.sparqlml.test;

import java.util.Random;

import com.hp.hpl.jena.ontology.OntClass;
import com.hp.hpl.jena.ontology.OntModel;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.rdf.model.Property;
import com.hp.hpl.jena.rdf.model.Resource;
import com.hp.hpl.jena.rdf.model.ResourceFactory;

public class DataGenerator {

	static OntModel m;

	public static String ONT = "http://www.examplecompany.org/";

	private static String RDF_PREFIX = "http://www.w3.org/1999/02/22-rdf-syntax-ns#";

	public static void main(String[] args) {

		Random randNum;
		randNum = new Random();

		m = ModelFactory.createOntologyModel();
		m.setNsPrefix("ex", ONT);

		OntClass project = m.createClass(ONT + "Project");
		Property success = m.createProperty(ONT + "isSuccess");
		Property team = m.createProperty(ONT + "hasTeam");
		Property rdfType = m.createProperty(RDF_PREFIX + "type");

		int numProjects = 200;
		int[] numTeam = { 6 };

		int[] boardMgr = { 1, 2, 3, 4, 5 };
		int[] divisionMgr = { 6, 7, 8, 9, 10, 11 };
		int[] productMgr = { 12 };
		int[] salesMgr = { 13 };

		int[] admin = { 15, 16, 17, 18 };
		int[] marketing = { 19, 20, 21, 22, 23, 24 };
		int[] production = { 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35 };
		int[] sales = { 36, 37, 38, 39, 40, 41, 42 };

		int[] employees = { 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27,
				28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42 };

		int nonmanagerCount = 0;
		for (int i = 0; i < numProjects; i++) {
			Resource resProject = ResourceFactory
					.createResource(ONT + "PR" + i);

			int range = numTeam.length;
			//int index = randNum.nextInt(range);
			int index = 0;
			m.add(resProject, rdfType, project);


			/*
			// add board member
			if (numTeam[index] > 5) {
				int rngBoard = boardMgr.length;
				int rngIndex = randNum.nextInt(rngBoard);
				m.add(resProject, team, ResourceFactory.createResource(ONT
						+ "P" + boardMgr[rngIndex]));
			}
			*/

			/*
			// add production manager
			if (numTeam[index] > 5) {
				int random = randNum.nextInt(2);
				if (random == 0) {
					int rngProduct = productMgr.length;
					int rngIndex = randNum.nextInt(rngProduct);
					m.add(resProject, team, ResourceFactory.createResource(ONT
							+ "P" + productMgr[rngIndex]));
				} else {
					int rngSales = salesMgr.length;
					int rngIndex = randNum.nextInt(rngSales);
					m.add(resProject, team, ResourceFactory.createResource(ONT
							+ "P" + salesMgr[rngIndex]));
				}
			}
			*/

			boolean hasDivision = false;

			for (int j = 0; j < numTeam[index]; j++) {

				/*
				if (!hasDivision) {
					int rngdivision = divisionMgr.length;
					int rngIndex = randNum.nextInt(rngdivision);
					m.add(resProject, team, ResourceFactory.createResource(ONT
							+ "P" + divisionMgr[rngIndex]));
					hasDivision = true;
				} else {
					int rngemployee = employees.length;
					int rngIndex = randNum.nextInt(rngemployee);
					m.add(resProject, team, ResourceFactory.createResource(ONT
							+ "P" + employees[rngIndex]));
				}
				*/
				int rngIndex = randNum.nextInt(42);
				m.add(resProject, team, ResourceFactory.createResource(ONT
						+ "P" + rngIndex));
				for (int z=0; z < employees.length; z++){
					if (employees[z] == rngIndex) {
						nonmanagerCount++;
					}
				}

			}
			

			if (nonmanagerCount > 3) 
				m.add(resProject, success, "NO");
			else
				m.add(resProject, success, "YES");
			
			nonmanagerCount = 0;

		}

		m.write(System.out, "RDF/XML-ABBREV");

	}
}
