package ch.uzh.ifi.sparqlml.test;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import ch.uzh.ifi.sparqlml.arq.create.query.QueryExecutionFactoryML;
import ch.uzh.ifi.sparqlml.arq.create.query.QueryExecutionML;
import ch.uzh.ifi.sparqlml.arq.create.query.QueryFactoryML;
import ch.uzh.ifi.sparqlml.arq.create.query.QueryML;

import com.hp.hpl.jena.query.ResultSet;
import com.hp.hpl.jena.query.ResultSetFormatter;
import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.util.FileManager;

public class TestClass {

	private static Model data = ModelFactory.createDefaultModel();

	public static void main(String[] args) {

		String inQueryFileName = null;
		String inGraphFileName = null;
		String qstr = null;

		if (args.length > 0) {
			for (int i = 0; i < args.length; i++) {
				if (args[i].equals("--query"))
					inQueryFileName = args[i + 1];
				else if (args[i].equals("--data"))
					inGraphFileName = args[i + 1];
			}
		}

		if (inQueryFileName != null) {
			qstr = inQueryString(inQueryFileName);
		}

		InputStream in = FileManager.get().open(inGraphFileName);
		data.read(in, "");

		QueryML query = QueryFactoryML.create(qstr);
		QueryExecutionML qe = QueryExecutionFactoryML.create(query, data);

		Model testModel = qe.execCreate();
		testModel.write(System.out, "RDF/XML-ABBREV", "");

		ResultSet results = qe.execSelect();
		ResultSetFormatter.out(System.out, results, query);
	}

	private static String inQueryString(String inQueryFileName) {
		String line = "";
		BufferedReader br = null;
		String inQueryString = "";

		try {
			br = new BufferedReader(new InputStreamReader(new FileInputStream(
					inQueryFileName)));
		} catch (FileNotFoundException e) {
			System.out.println(e);
		}
		try {
			while ((line = br.readLine()) != null) {
				inQueryString = inQueryString + line + "\n";
			}
		} catch (IOException e) {
		}

		return inQueryString;
	}
}
