package ch.uzh.ifi.sparqlml.test.owlstc;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import com.hp.hpl.jena.graph.Node;
import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.rdf.model.RDFNode;
import com.hp.hpl.jena.rdf.model.Resource;
import com.hp.hpl.jena.rdf.model.ResourceFactory;
import com.hp.hpl.jena.rdf.model.Statement;
import com.hp.hpl.jena.rdf.model.StmtIterator;
import com.hp.hpl.jena.util.FileManager;

public class owlstcPrepare {

	Model m = ModelFactory.createDefaultModel();

	public static void main(String[] args) {

		// get domains
		File dirs = new File("test/owls-tc2/domains");
		String[] children = dirs.list();

		// get files
		for (int i = 0; i < children.length; i++) {
			File dir = new File("test/owls-tc2/domains/" + children[i]);
			String[] files = dir.list();
			String domain = children[i];
			for (int j = 0; j < files.length; j++) {
				String file = files[j];
				openModel(domain, file);
			}

		}

	}

	private static void openModel(String domain, String file) {
		Model container = ModelFactory.createDefaultModel();
		InputStream in = null;
		in = FileManager.get().open(
				"test/owls-tc2/domains/" + domain + "/" + file);
		container.read(in, "", "RDF/XML-ABBREV");
		changeParameter(container);
		addDomain(container, domain);

		OutputStream out = null;
		try {
			out = new FileOutputStream("test/owls-tc2/domains/" + domain + "/"
					+ file);
		} catch (FileNotFoundException e) {
			System.out.println("Missing meta_models.rdf file.");
			e.printStackTrace();
		}
		container.write(out, "RDF/XML-ABBREV");

		container.close();
	}

	private static void addDomain(Model container, String domain) {
		String paramProp = "http://www.daml.org/services/owl-s/1.1/Service.owl#presents";
		String domainProp = "http://www.daml.org/services/owl-s/1.1/Service.owl#hasDomain";
		StmtIterator i = container.listStatements(null, ResourceFactory
				.createProperty(paramProp), (RDFNode) null);

		List l = i.toList();
		Resource subject = null;
		String object = "";

		for (int v = 0; v < l.size(); v++) {
			Statement t = (Statement) l.get(v);
			subject = t.getSubject();
		}

		container.add(subject, ResourceFactory.createProperty(domainProp),
				domain);
	}

	private static void changeParameter(Model container) {
		String paramProp = "http://www.daml.org/services/owl-s/1.1/Process.owl#parameterType";
		StmtIterator i = container.listStatements(null, ResourceFactory
				.createProperty(paramProp), (RDFNode) null);

		List l = i.toList();

		Resource subject = null;
		String object = "";

		for (int v = 0; v < l.size(); v++) {
			Statement t = (Statement) l.get(v);
			subject = t.getSubject();
			object = t.getObject().asNode().getLiteralLexicalForm();
			t.changeObject(ResourceFactory.createResource(object));
		}

		StmtIterator u = container.listStatements(null, ResourceFactory
				.createProperty(paramProp), (RDFNode) null);

		while (u.hasNext()) {
			Statement t = (Statement) u.next();
			// System.out.println(t);
		}
	}
}
