package ch.uzh.ifi.sparqlml.test.swrc;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map.Entry;

import com.hp.hpl.jena.graph.Node;
import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.rdf.model.NodeIterator;
import com.hp.hpl.jena.rdf.model.RDFNode;
import com.hp.hpl.jena.rdf.model.Resource;
import com.hp.hpl.jena.rdf.model.ResourceFactory;
import com.hp.hpl.jena.rdf.model.Statement;
import com.hp.hpl.jena.rdf.model.StmtIterator;
import com.hp.hpl.jena.util.FileManager;

public class AddPaperAffiliation {

	public static String file = "test/swrc/aifb_november2006.owl";

	public static void main(String[] args) {
		Model publications = ModelFactory.createDefaultModel();
		publications.setNsPrefix("swrc", "http://swrc.ontoware.org/ontology#");
		Model container = ModelFactory.createDefaultModel();
		InputStream in = null;
		in = FileManager.get().open(file);
		container.read(in, "");

		// export publications
		StmtIterator i = container.listStatements(null, ResourceFactory
				.createProperty("http://swrc.ontoware.org/ontology#year"),
				(RDFNode) null);

		List l = i.toList();

		int countPublications = 1;

		for (int v = 0; v < l.size(); v++) {
			Statement t = (Statement) l.get(v);

			HashMap affiliations = new HashMap();
			String finalAffiliation = "";

			// get all authors
			StmtIterator authorsIter = container
					.listStatements(
							t.getSubject(),
							ResourceFactory
									.createProperty("http://swrc.ontoware.org/ontology#author"),
							(RDFNode) null);
			List authors = authorsIter.toList();
			for (int x = 0; x < authors.size(); x++) {
				Statement u = (Statement) authors.get(x);
				Resource author = (Resource) u.getObject();

				// get all affiliations of author
				NodeIterator researchGroup = container
						.listObjectsOfProperty(
								author,
								ResourceFactory
										.createProperty("http://swrc.ontoware.org/ontology#affiliation"));
				List r = researchGroup.toList();
				for (int q = 0; q < r.size(); q++) {
					RDFNode a = (RDFNode) r.get(q);
					String ar = a.asNode().getLocalName();
					if (affiliations.containsKey(ar)) {
						Integer count = (Integer) affiliations.get(ar);
						count++;
						affiliations.put(ar, count);
					} else {
						affiliations.put(ar, 1);
					}
				}
			}

			// get mode(affiliation)
			Iterator mode = affiliations.entrySet().iterator();
			int maxCount = 0;
			while (mode.hasNext()) {
				Entry e = (Entry) mode.next();
				String classLabel = (String) e.getKey();
				Integer counter = (Integer) e.getValue();
				if (counter > maxCount) {
					finalAffiliation = classLabel;
					maxCount = counter;
				}
			}
			System.out.println(countPublications + " " + t.getSubject() + ": "
					+ finalAffiliation + " (" + maxCount + ")");
			// add triple

			if (!finalAffiliation.equals("")) {
				container
						.add(
								t.getSubject(),
								ResourceFactory
										.createProperty("http://swrc.ontoware.org/ontology#fromGroup"),
								(finalAffiliation));
			}
			// save publications

			StmtIterator addIter = container.listStatements(t.getSubject(),
					null, (RDFNode) null);
			List ladd = addIter.toList();

			for (int x = 0; x < ladd.size(); x++) {
				Statement u = (Statement) ladd.get(x);
				publications.add(u);
				container.remove(u);
			}
			countPublications++;
		}
		OutputStream outPerson = null;
		try {
			outPerson = new FileOutputStream(
					"test/swrc/aifb_november2006_publications.owl");
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		publications.write(outPerson);

		// output original file

		OutputStream out = null;
		try {
			out = new FileOutputStream(
					"test/swrc/aifb_november2006_data_publications.owl");
		} catch (FileNotFoundException e) {
			System.out.println("Missing meta_models.rdf file.");
			e.printStackTrace();
		}
		container.write(out);

		container.close();

	}

	private static void addTriples(Model container) {
		String prop = "http://swrc.ontoware.org/ontology#worksAtTopic";

		StmtIterator i = container
				.listStatements(
						null,
						ResourceFactory
								.createProperty("http://swrc.ontoware.org/ontology#isWorkedOnBy"),
						(RDFNode) null);

		List l = i.toList();

		Resource subject = null;
		Resource object = null;

		for (int v = 0; v < l.size(); v++) {
			Statement t = (Statement) l.get(v);
			subject = t.getSubject();
			object = (Resource) t.getObject();
			container
					.add(object, ResourceFactory.createProperty(prop), subject);
		}

	}

}
