package ch.uzh.ifi.sparqlml.test.swrc;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.List;

import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.rdf.model.RDFNode;
import com.hp.hpl.jena.rdf.model.Resource;
import com.hp.hpl.jena.rdf.model.ResourceFactory;
import com.hp.hpl.jena.rdf.model.Statement;
import com.hp.hpl.jena.rdf.model.StmtIterator;
import com.hp.hpl.jena.util.FileManager;

public class AddTriples {

	public static String file = "test/swrc/aifb_november2006.owl";

	public static void main(String[] args) {
		Model persons = ModelFactory.createDefaultModel();
		persons.setNsPrefix("swrc", "http://swrc.ontoware.org/ontology#");
		Model container = ModelFactory.createDefaultModel();
		InputStream in = null;
		in = FileManager.get().open(file);
		container.read(in, "");

		// add topic triples
		addTriples(container);

		// export persons
		StmtIterator i = container
				.listStatements(
						null,
						ResourceFactory
								.createProperty("http://swrc.ontoware.org/ontology#affiliation"),
						(RDFNode) null);

		List l = i.toList();

		for (int v = 0; v < l.size(); v++) {
			Statement t = (Statement) l.get(v);
			StmtIterator addIter = container.listStatements(t.getSubject(),
					null, (RDFNode) null);
			List ladd = addIter.toList();

			for (int x = 0; x < ladd.size(); x++) {
				Statement u = (Statement) ladd.get(x);
				persons.add(u);
				container.remove(u);
			}
		}
		OutputStream outPerson = null;
		try {
			outPerson = new FileOutputStream(
					"test/swrc/aifb_november2006_person.owl");
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		persons.write(outPerson);

		// output original file

		OutputStream out = null;
		try {
			out = new FileOutputStream(file);
		} catch (FileNotFoundException e) {
			System.out.println("Missing meta_models.rdf file.");
			e.printStackTrace();
		}
		container.write(out);

		container.close();

	}

	private static void addTriples(Model container) {
		String prop = "http://swrc.ontoware.org/ontology#worksAtTopic";

		StmtIterator i = container
				.listStatements(
						null,
						ResourceFactory
								.createProperty("http://swrc.ontoware.org/ontology#isWorkedOnBy"),
						(RDFNode) null);

		List l = i.toList();

		Resource subject = null;
		Resource object = null;

		for (int v = 0; v < l.size(); v++) {
			Statement t = (Statement) l.get(v);
			subject = t.getSubject();
			object = (Resource) t.getObject();
			container
					.add(object, ResourceFactory.createProperty(prop), subject);
		}

	}

}
