package ch.uzh.ifi.sparqlml.test.swrc;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;

import ch.uzh.ifi.sparqlml.arq.create.query.QueryExecutionFactoryML;
import ch.uzh.ifi.sparqlml.arq.create.query.QueryExecutionML;
import ch.uzh.ifi.sparqlml.arq.create.query.QueryFactoryML;
import ch.uzh.ifi.sparqlml.arq.create.query.QueryML;

import com.hp.hpl.jena.graph.Node;
import com.hp.hpl.jena.ontology.OntModel;
import com.hp.hpl.jena.ontology.OntModelSpec;
import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.rdf.model.RDFNode;
import com.hp.hpl.jena.rdf.model.Resource;
import com.hp.hpl.jena.rdf.model.ResourceFactory;
import com.hp.hpl.jena.rdf.model.Statement;
import com.hp.hpl.jena.rdf.model.StmtIterator;
import com.hp.hpl.jena.util.FileManager;

public class Publication2Affiliation {

	public static String instances = "test/swrc/publication2affiliation/aifb_november2006_publication.owl";

	public static String instancesData = "test/swrc/publication2affiliation/aifb_november2006_data_publication.owl";

	public static String qstrInduce = "test/swrc/publication2affiliation/induce_publication.rq";

	public static String qstrApply = "test/swrc/publication2affiliation/apply_publication.rq";

	private static Model persons = ModelFactory.createDefaultModel();

	private static Model personsCopy = ModelFactory.createDefaultModel();

	private static Model data = ModelFactory.createDefaultModel();

	private static Model ontModel = ModelFactory.createDefaultModel();

	// private static Model ontModel = ModelFactory.createDefaultModel();

	public static void main(String[] args) {
		String qstr = "";
		int counter = 1;
		Statement testSet = null;
		ArrayList<Resource> personList = new ArrayList<Resource>();

		// open person model

		// open data model
		InputStream inData = FileManager.get().open(instancesData);
		data.read(inData, "");

		for (int x = 0; x < 1155; x++) {

			ontModel.removeAll();
			persons.removeAll();

			InputStream inPerson = FileManager.get().open(instances);
			persons.read(inPerson, "");

			StmtIterator i = persons
					.listStatements(
							null,
							ResourceFactory
									.createProperty("http://swrc.ontoware.org/ontology#fromGroup"),
							(RDFNode) null);

			int test = 0;
			while (i.hasNext()) {
				Statement stmt = i.nextStatement();
				if (!personList.contains(stmt.getSubject())) {
					testSet = stmt;
					personList.add(stmt.getSubject());
					test = 1;
					break;
				} else {
				}
			}
			if (test != 1) {
				System.out.println("ERROR");
			}

			// remove test person
			persons.remove(testSet);
			System.out.println("REMOVE: " + testSet);

			// open training data and add training persons
			ontModel.add(persons);
			ontModel.add(data);

			// induce model
			qstr = inQueryString(qstrInduce);
			System.out.println(counter + ": Inducing Model...");
			QueryML queryInduce = QueryFactoryML.create(qstr);
			QueryExecutionML qeInduce = QueryExecutionFactoryML.create(
					queryInduce, ontModel);
			qeInduce.execCreate();

			// open person model
			ontModel.removeAll();
			persons.removeAll();
			InputStream inPerson2 = FileManager.get().open(instances);
			persons.read(inPerson2, "");

			ontModel.add(data);

			StmtIterator iApply = persons.listStatements(testSet.getSubject(),
					null, (RDFNode) null);

			while (iApply.hasNext()) {
				Statement stmt = iApply.nextStatement();
				ontModel.add(stmt);
			}

			// apply model
			qstr = inQueryString(qstrApply);
			System.out.println(counter + ": Applying Model...");
			QueryML queryApply = QueryFactoryML.create(qstr);
			QueryExecutionML qeApply = QueryExecutionFactoryML.create(
					queryApply, ontModel);
			qeApply.execSelect();

			counter++;
		}

	}

	// Read the query from file
	private static String inQueryString(String inQueryFileName) {
		String line = "";
		BufferedReader br = null;
		String inQueryString = "";

		try {
			br = new BufferedReader(new InputStreamReader(new FileInputStream(
					inQueryFileName)));
		} catch (FileNotFoundException e) {
			System.out.println(e);
		}

		try {
			while ((line = br.readLine()) != null) {
				inQueryString = inQueryString + line + "\n";
			}
		} catch (IOException e) {
		}

		return inQueryString;
	}

	private static void usage() {
		System.out.println("ch.unizh.ifi.sparqlml.arq.sparqlml [options]");
		System.out.println("Options:");
		System.out.println("--query");
		System.out.println("--data");
		System.out.println("--help");

		System.exit(0);
	}
}
